package com.example.proiectpm

import android.annotation.SuppressLint
import android.bluetooth.BluetoothAdapter
import android.bluetooth.BluetoothGatt
import android.bluetooth.BluetoothGattCallback
import android.bluetooth.BluetoothGattCharacteristic
import android.bluetooth.BluetoothProfile
import android.bluetooth.le.BluetoothLeScanner
import android.bluetooth.le.ScanCallback
import android.bluetooth.le.ScanFilter
import android.bluetooth.le.ScanResult
import android.bluetooth.le.ScanSettings
import android.content.Intent
import android.os.Bundle
import android.widget.Button
import androidx.activity.ComponentActivity
import java.util.*

@Suppress("DEPRECATION")
class MainActivity : ComponentActivity() {

    private lateinit var bluetoothAdapter: BluetoothAdapter

    private lateinit var bluetoothGatt: BluetoothGatt
    private lateinit var characteristic: BluetoothGattCharacteristic


    @SuppressLint("MissingPermission")
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

//        bluetoothAdapter = BluetoothAdapter.getDefaultAdapter()
//
//        if (!bluetoothAdapter.isEnabled) {
//            val enableBluetoothIntent = Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE)
//            startActivityForResult(enableBluetoothIntent, 1)
//        }
//
//        val gattCallback = object : BluetoothGattCallback() {
//            override fun onConnectionStateChange(gatt: BluetoothGatt?, status: Int, newState: Int) {
//                when (newState) {
//                    BluetoothProfile.STATE_CONNECTED -> {
//                        // Connected to the HM-10 module, discover services
//                        gatt?.discoverServices()
//                    }
//                    BluetoothProfile.STATE_DISCONNECTED -> {
//                        // Disconnected from the HM-10 module
//                    }
//                }
//            }
//        }
//
//        val bluetoothLeScanner: BluetoothLeScanner = bluetoothAdapter.bluetoothLeScanner
//        val scanCallback = object : ScanCallback() {
//            @SuppressLint("MissingPermission")
//            override fun onScanResult(callbackType: Int, result: ScanResult?) {
//                result?.device?.let { device ->
//                    if (device.name == "HM-10") {
//                        // Found the HM-10 module, connect to it
//                        device.connectGatt(applicationContext, false, gattCallback)
//                    }
//                }
//            }
//        }
//        val scanFilter = ScanFilter.Builder()
//            .setDeviceName("HM-10")
//            .build()
//        val scanSettings = ScanSettings.Builder()
//            .setScanMode(ScanSettings.SCAN_MODE_LOW_POWER)
//            .build()
//        bluetoothLeScanner.startScan(listOf(scanFilter), scanSettings, scanCallback)


        setContentView(R.layout.app_layout)

        val button1 = findViewById<Button>(R.id.simpleButton1)
        val button2 = findViewById<Button>(R.id.simpleButton2)
        val button3 = findViewById<Button>(R.id.simpleButton3)

        button1.setOnClickListener {
            println("Ambulance Mode!")
            val dataToSend = "0"

            if (characteristic.properties and BluetoothGattCharacteristic.PROPERTY_WRITE != 0) {
                characteristic.value = dataToSend.toByteArray()
                bluetoothGatt.writeCharacteristic(characteristic)
            }
        }
        button2.setOnClickListener {
            println("Police Mode!")
            val dataToSend = "1"

            if (characteristic.properties and BluetoothGattCharacteristic.PROPERTY_WRITE != 0) {
                characteristic.value = dataToSend.toByteArray()
                bluetoothGatt.writeCharacteristic(characteristic)
            }
        }
        button3.setOnClickListener {
            println("Firefighters Mode!")
            val dataToSend = "2"

            if (characteristic.properties and BluetoothGattCharacteristic.PROPERTY_WRITE != 0) {
                characteristic.value = dataToSend.toByteArray()
                bluetoothGatt.writeCharacteristic(characteristic)
            }
        }
    }
}